--AH:ScriptId=33c52d10-48e0-4005-9668-2ccf7d5ccc04;307
CREATE TABLE [Features] (
	[Feature_Code] CHAR(3) NOT NULL
		CONSTRAINT [PK__Features]
		PRIMARY KEY ([Feature_Code]),
	[Feature_Description] VARCHAR(MAX) NOT NULL
)

CREATE TABLE [FeatureLevels] (
	[FeatureLevel_Id] INT IDENTITY(1,1) NOT NULL
		CONSTRAINT [PK__FeatureLevels]
		PRIMARY KEY,
	[Feature_Code] CHAR(3) NULL,
		CONSTRAINT [FK__FeatureLevels__Features]
		FOREIGN KEY ([Feature_Code])
		REFERENCES [Features] ([Feature_Code]),
	[Application_Id] INT NULL
		CONSTRAINT [FK__FeatureLevels__Applications]
		FOREIGN KEY ([Application_Id])
		REFERENCES [Applications]([Application_Id]),
	[Feature_Level] INT NOT NULL
		CONSTRAINT [CK__FeatureLevels__FeatureLevel]
		CHECK ([Feature_Level] BETWEEN 0 AND 7)
	CONSTRAINT [UQ__FeatureLevels]
		UNIQUE ([Feature_Code],[Application_Id])
)

INSERT INTO [Features] ([Feature_Code],[Feature_Description])
SELECT 'CFG', 'Configuration Files' UNION ALL
SELECT 'DBS', 'Database Change Scripts' UNION ALL
SELECT 'CCT', 'Change Controls' UNION ALL
SELECT 'BSH', 'Build Schedules' UNION ALL
SELECT 'WKF', 'Promotion Workflows' UNION ALL
SELECT 'VAR', 'Variables' UNION ALL
SELECT 'PLN', 'Deployment Plans' 

INSERT INTO [FeatureLevels] ([Feature_Code],[Feature_Level])
SELECT NULL, 1 UNION ALL
SELECT 'CCT', 0