--AH:ScriptId=43343e56-fe31-4b54-95df-e28c1026a722;2901

DECLARE @TmpProviders TABLE (
    [Provider_Id] INT NOT NULL,
    [Provider_Configuration] XML NOT NULL,
    [New_Provider_Configuration] XML NULL
)

DECLARE @TmpRepos TABLE (
    [Name] VARCHAR(MAX),
    [CustomDiskPath] VARCHAR (MAX),
    [RemoteUrl] VARCHAR(MAX)
)

DECLARE @Current_Provider_Id INT
DECLARE @Current_Provider_Configuration XML
DECLARE @New_Provider_Configuration XML

INSERT @TmpProviders ([Provider_Id], [Provider_Configuration])
SELECT [Provider_Id], [Provider_Configuration] FROM [Providers]
WHERE [ProviderType_Code] = 'S'

WHILE EXISTS(SELECT * FROM @TmpProviders WHERE [New_Provider_Configuration] IS NULL) 
BEGIN
    
    SELECT TOP 1 @Current_Provider_Id = [Provider_Id], @Current_Provider_Configuration = [Provider_Configuration] FROM @TmpProviders
    WHERE [New_Provider_Configuration] IS NULL

    SET @New_Provider_Configuration = @Current_Provider_Configuration

    IF @Current_Provider_Configuration.exist('/Inedo.BuildMasterExtensions.Git.GitSourceControlProvider') = 1
    BEGIN
        -- Git
        INSERT @TmpRepos ([Name], [CustomDiskPath], [RemoteUrl])
        SELECT PROPS.col.value('@RepositoryPath[1]', 'varchar(max)'),
               '',
               PROPS.col.value('@RemoteRepositoryUrl[1]', 'varchar(max)')
        FROM @Current_Provider_Configuration.nodes('/Inedo.BuildMasterExtensions.Git.GitSourceControlProvider/Properties/Repositories/Inedo.BuildMasterExtensions.Git.GitRepository/Properties') PROPS(col)
    END
    ELSE IF @Current_Provider_Configuration.exist('/Inedo.BuildMasterExtensions.Subversion.Subversion15Provider') = 1
    BEGIN
        -- Subversion
        INSERT @TmpRepos ([Name], [CustomDiskPath], [RemoteUrl])
        SELECT PROPS.col.value('@SvnRepositoryName[1]', 'varchar(max)'),
               '',
               PROPS.col.value('@RepositoryPath[1]', 'varchar(max)')
        FROM @Current_Provider_Configuration.nodes('/Inedo.BuildMasterExtensions.Subversion.Subversion15Provider/Properties/Repositories/Inedo.BuildMasterExtensions.Subversion.SubversionRepository/Properties') PROPS(col)
    END
    ELSE IF @Current_Provider_Configuration.exist('/Inedo.BuildMasterExtensions.Mercurial.MercurialProvider') = 1
    BEGIN
        -- Mercurial
        INSERT @TmpRepos ([Name], [CustomDiskPath], [RemoteUrl])
        SELECT '',
               PROPS.col.value('@RepositoryPath[1]', 'varchar(max)'),
               PROPS.col.value('@RemoteRepositoryUrl[1]', 'varchar(max)')
        FROM @Current_Provider_Configuration.nodes('/Inedo.BuildMasterExtensions.Mercurial.MercurialProvider/Properties/Repositories/Inedo.BuildMasterExtensions.Mercurial.MercurialRepository/Properties') PROPS(col)
    END

    IF EXISTS(SELECT * FROM @TmpRepos)
    BEGIN
        DECLARE @sourceRepos XML
        SET @sourceRepos = (SELECT 
                                (SELECT [@Name] = COALESCE([Name], ''),
                                        [@CustomDiskPath] = COALESCE([CustomDiskPath], ''),
                                        [@RemoteUrl] = COALESCE([RemoteUrl], '')
                                   FROM @TmpRepos
                                    FOR XML PATH ('SourceRepository'), TYPE)
                               FOR XML PATH ('Repositories'), TYPE)
        
        DECLARE @rubbish NVARCHAR(MAX)
        SET @rubbish = CAST(@sourceRepos AS NVARCHAR(MAX))
        DECLARE @newConfig NVARCHAR(MAX)

        SET @newConfig = CAST(@New_Provider_Configuration AS NVARCHAR(MAX))
        
        DECLARE @left NVARCHAR(MAX)
        DECLARE @right NVARCHAR(MAX)

        SET @left = SUBSTRING(@newConfig, 0, CHARINDEX('<Repositories', @newConfig))
        SET @right = SUBSTRING(@newConfig, CHARINDEX('/Repositories>', @newConfig) + 14, DATALENGTH(@newConfig))
        SET @rubbish = @left + @rubbish + @right
        SET @New_Provider_Configuration = CAST(@rubbish AS XML)

        -- *** The rubbish above replaces the rubbish below... ***
        --SET @New_Provider_Configuration.modify('delete (/*/Properties/Repositories)[1]')
        --SET @New_Provider_Configuration.modify('insert sql:variable("@sourceRepos") into (/*/Properties)[1]')
    END

    UPDATE @TmpProviders 
       SET [New_Provider_Configuration] = @New_Provider_Configuration 
     WHERE [Provider_Id] = @Current_Provider_Id

     DELETE @TmpRepos

END

UPDATE [Providers]
   SET [Provider_Configuration] = TMP.[New_Provider_Configuration]
  FROM [Providers] P
 INNER JOIN @TmpProviders TMP ON TMP.[Provider_Id] = P.[Provider_Id]