--AH:ScriptId=55143202-33ec-4354-aa89-271f4f595ced;2905
CREATE TABLE [Issues]
(
	[Application_Id] INT NOT NULL,
	[Issue_Id] INT NOT NULL,
	[Release_Number] RELEASENUMBER NOT NULL,

	[IssueTracker_IssueId_Text] NVARCHAR(100) NULL,
	[IssueTracker_IssueStatus_Text] NVARCHAR(100) NULL,
	[IssueTracker_LastSync_Date] DATETIME NULL,
	[IssueTracker_Original_Name] NVARCHAR(MAX) NULL,
	[IssueTracker_Overridden_Date] DATETIME NULL,

	[Title_Text] NVARCHAR(200) NOT NULL,
	[Description_Text] NVARCHAR(MAX) NOT NULL,
	[Closed_Indicator] YNINDICATOR NOT NULL,
	[Deleted_Indicator] YNINDICATOR NOT NULL,

	[CreatedBy_User_Name] USERNAME NOT NULL,
	[CreatedOn_Date] DATETIME NOT NULL,

	CONSTRAINT [PK__Issues]
		PRIMARY KEY ([Application_Id], [Issue_Id]),

	CONSTRAINT [FK__Issues__Applications]
		FOREIGN KEY ([Application_Id])
		REFERENCES [Applications] ([Application_Id]),

	CONSTRAINT [FK__Issues__Releases]
		FOREIGN KEY ([Application_Id], [Release_Number])
		REFERENCES [Releases] ([Application_Id], [Release_Number]),

	CONSTRAINT [CK__Issues__Issue_Id]
		CHECK ([Issue_Id] > 0)
)

CREATE TABLE [Issues_BuildStatusChanges]
(
	[Application_Id] INT NOT NULL,
	[Release_Number] RELEASENUMBER NOT NULL,
	[Build_Number] BUILDNUMBER NOT NULL,
	[Issue_Id] INT NOT NULL,
	[New_IssueStatus_Text] NVARCHAR(MAX) NOT NULL,
	[StatusChanged_Date] DATETIME NOT NULL,
	[StatusChangedBy_User_Name] USERNAME NOT NULL,

	CONSTRAINT [FK__Issues_BuildStatusChanges__Builds]
		FOREIGN KEY ([Application_Id], [Release_Number], [Build_Number])
		REFERENCES [Builds] ([Application_Id], [Release_Number], [Build_Number]),

	CONSTRAINT [FK__Issues_BuildStatusChanges__Issues]
		FOREIGN KEY ([Application_Id], [Issue_Id])
		REFERENCES [Issues] ([Application_Id], [Issue_Id])
)

CREATE CLUSTERED INDEX [IX__Issues_BuildStatusChanges__Build]
	ON [Issues_BuildStatusChanges] ([Application_Id], [Release_Number], [Build_Number])

CREATE NONCLUSTERED INDEX [IX__Issues_BuildStatusChanges__Issues]
	ON [Issues_BuildStatusChanges] ([Application_Id], [Issue_Id])
