IF OBJECT_ID('[BuildPromotions_Extended]') IS NOT NULL DROP VIEW [BuildPromotions_Extended]
GO

CREATE VIEW [BuildPromotions_Extended] AS

SELECT BP.*

      ,A.[Application_Id]
      ,A.[Application_Name]

      ,R.[Release_Id]
      ,R.[Release_Number]
      ,[Release_Name] = COALESCE(R.[Release_Name], R.[Release_Number])

      ,B.[Build_Number]
      ,B.[BuildStatus_Name]

      ,[Pipeline_Name] = COALESCE(B.[Pipeline_Name], R.[Pipeline_Name])

  FROM [BuildPromotions] BP
       INNER JOIN [Builds] B
               ON B.[Build_Id] = BP.[Build_Id]
       LEFT JOIN [Releases] R
               ON R.[Release_Id] = B.[Release_Id]
       LEFT JOIN [Applications] A
               ON A.[Application_Id] = B.[Application_Id]
GO
