IF OBJECT_ID('[ConfigurationFileVersions_Combined]') IS NOT NULL DROP VIEW [ConfigurationFileVersions_Combined]
GO

CREATE VIEW [ConfigurationFileVersions_Combined] AS

SELECT CF.[ConfigurationFile_Id],
       CFV.[Version_Number],
	   CF.[ConfigurationFile_Name],
	   CF.[FilePath_Text],
	   [Version_CreatedOn_Date] = CFV.[CreatedOn_Date],
	   [Version_CreatedBy_User_Name] = CFV.[CreatedBy_User_Name],
	   CFV.[VersionNotes_Text]
  FROM [ConfigurationFiles] CF
       INNER JOIN (SELECT [ConfigurationFile_Id],
                          [Version_Number],
	                      [CreatedOn_Date] = MAX([CreatedOn_Date]),
						  [CreatedBy_User_Name] = MAX([CreatedBy_User_Name]),
                          [VersionNotes_Text] = MAX([VersionNotes_Text])
                     FROM [ConfigurationFileVersions]
                    GROUP BY [ConfigurationFile_Id], [Version_Number]) CFV
			   ON CFV.[ConfigurationFile_Id] = CF.[ConfigurationFile_Id]

GO
