EXEC [dbo].[__BuildMaster_AddStoredProcInfo]
    /* StoredProc_Name         */ 'AdminEdit_UpdateExecutionStatus',
    /* Internal_Indicator      */ 'N',
    /* ReturnType_Name         */ 'void',
    /* DataTableNames_Csv      */ NULL,
    /* OutputPropertyNames_Csv */ NULL,
    /* Description_Text        */ 'Updates the status of an execution.',
    /* Remarks_Text            */ NULL
GO

IF OBJECT_ID('[AdminEdit_UpdateExecutionStatus]') IS NOT NULL DROP PROCEDURE [AdminEdit_UpdateExecutionStatus]
GO

SET QUOTED_IDENTIFIER ON
GO

CREATE PROCEDURE [AdminEdit_UpdateExecutionStatus]
(
	@Execution_Id INT,
    @ExecutionStatus_Code CHAR(1)
)
AS
BEGIN

    SET NOCOUNT ON


BEGIN TRY
	BEGIN TRANSACTION

        UPDATE [Executions]
           SET [ExecutionStatus_Code] = @ExecutionStatus_Code
         WHERE [Execution_Id] = @Execution_Id
    
    COMMIT

END TRY BEGIN CATCH
	IF XACT_STATE()<>0 ROLLBACK
	EXEC [HandleError]
END CATCH

END
GO

GRANT EXECUTE ON [AdminEdit_UpdateExecutionStatus] TO [BuildMasterUser_Role]
