EXEC [dbo].[__BuildMaster_AddStoredProcInfo]
    /* StoredProc_Name         */ 'Packages_GetPackages',
    /* Internal_Indicator      */ 'N',
    /* ReturnType_Name         */ 'void',
    /* DataTableNames_Csv      */ 'Packages_Extended',
    /* OutputPropertyNames_Csv */ NULL,
    /* Description_Text        */ 'Gets the packages that match the specified criteria.'
GO

IF OBJECT_ID('[Packages_GetPackages]') IS NOT NULL DROP PROCEDURE [Packages_GetPackages]
GO


SET QUOTED_IDENTIFIER ON
GO

CREATE PROCEDURE [Packages_GetPackages]
(
	@Build_Id INT,
    @Package_Name NVARCHAR(255) = NULL,
	@PackageSource_Name VARCHAR(50) = NULL
)
AS
BEGIN

SET NOCOUNT ON

	SELECT * 
	  FROM [Packages_Extended]
	 WHERE [Build_Id] = @Build_Id
	   AND (@Package_Name IS NULL OR [Package_Name] = @Package_Name)
	   AND (@PackageSource_Name IS NULL OR [PackageSource_Name] = @PackageSource_Name)
	ORDER BY [PackageSource_Name], [Package_Name], [Version_Text]


END
GO

GRANT EXECUTE ON [Packages_GetPackages] TO [BuildMasterUser_Role]
