EXEC [dbo].[__BuildMaster_AddStoredProcInfo]
    /* StoredProc_Name         */ 'SecureResources_GetSecureResources',
    /* Internal_Indicator      */ 'N',
    /* ReturnType_Name         */ 'DataTable',
    /* DataTableNames_Csv      */ 'SecureResources',
    /* OutputPropertyNames_Csv */ NULL,
    /* Description_Text        */ 'Gets all secure resources in the system.'
GO


IF OBJECT_ID('[SecureResources_GetSecureResources]') IS NOT NULL DROP PROCEDURE [SecureResources_GetSecureResources]
GO

SET QUOTED_IDENTIFIER ON
GO

CREATE PROCEDURE [SecureResources_GetSecureResources]
AS
BEGIN

	SET NOCOUNT ON

	SELECT * 
	  FROM [SecureResources] SR
	       LEFT JOIN [Applications] A ON SR.[Application_Id] = A.[Application_Id]
	 ORDER BY A.[Application_Name], SR.[SecureResource_Name]

END
GO

GRANT EXECUTE ON [SecureResources_GetSecureResources] TO [BuildMasterUser_Role]